//========================================================
// Zabbix_Sender for Win32
// Simon A. F. Lund safl @ safl dot dk
// SoftCom Solututions www.softcom.dk
// This is a barebones port of zabbix_sender to windows
// No bells and whistles
//========================================================
#include <stdio.h>
#include <winsock.h>

// Error codes
#define SUCCEED         0
#define FAIL            (-1)
#define NOTSUPPORTED    (-2)
#define NETWORK_ERROR   (-3)
#define TIMEOUT_ERROR   (-4)
#define AGENT_ERROR     (-5)

int send_value(char *server, int port, char *shortname, char *value) {
    
	int     i,s;
	char    tosend[1024];
	char    result[1024];
	struct hostent *hp;
	struct sockaddr_in myaddr_in;
	struct sockaddr_in servaddr_in;

	WORD sockVersion;
	WSADATA wsaData;

	sockVersion = MAKEWORD(1, 1);
	WSAStartup(sockVersion, &wsaData);
	servaddr_in.sin_family=AF_INET;
	
	hp = gethostbyname (server);
	if(hp==NULL) {
		WSACleanup();
		return  FAIL;
	}

	servaddr_in.sin_addr.s_addr=((struct in_addr *)(hp->h_addr))->s_addr;
	servaddr_in.sin_port=htons(port);
	s=socket(AF_INET,SOCK_STREAM,0);
	if (s == -1) {
		WSACleanup();
		return  FAIL;
	}

	myaddr_in.sin_family = AF_INET;
	myaddr_in.sin_port=0;
	myaddr_in.sin_addr.s_addr=INADDR_ANY;

	if( connect(s,(struct sockaddr *)&servaddr_in,sizeof(struct sockaddr_in)) == -1 ) {
		closesocket(s);
		WSACleanup();
		return  FAIL;
	}

    /* Format the value to send    */
	sprintf(tosend,"%s:%s\n",shortname, value);

	if( sendto(s,tosend,strlen(tosend),0,(struct sockaddr *)&servaddr_in,sizeof(struct sockaddr_in)) == -1 ) {
		perror("sendto");
		closesocket(s);
		WSACleanup();
		return  FAIL;
	}

	i=sizeof(struct sockaddr_in);
	
	i=recvfrom(s,result,1023,0,(struct sockaddr *)&servaddr_in,&i);
	if(s==-1) {
		perror("recfrom");
		closesocket(s);
		WSACleanup();
		return  FAIL;
	}

	result[i-1]=0;
	if(strcmp(result,"OK") == 0) {
		//printf("OK\n");
	}

	if( closesocket(s)!=0 ) {
		perror("close");
	}

	WSACleanup();
	return SUCCEED;
}

int main(int argc, char* argv[]) {
	
  int     port;
	int     ret=SUCCEED;
  char zabbix_message[200];

	// Init global message string
	memset(zabbix_message,'\n',sizeof(zabbix_message)); 

  // If sufficient arguments has been passed, send info
	if(argc == 5) {
		port=atoi(argv[2]);
		ret = send_value(argv[1],port,argv[3],argv[4]);
	} else {
		printf("Usage: zabbix_sender <Zabbix server> <port> <server:key> <value>\n");
		ret = FAIL;
	}

	return ret;

}
